#include <sys/wait.h>
#include <sys/types.h>
#include <signal.h>
#include <errno.h>
#include <sys/socket.h>

#include <netinet/in.h>
#include <arpa/inet.h>


#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <pthread.h>

static __thread unsigned int tlsData = 0;
static volatile char runtask1 = 1;
static volatile char task1ended = 0;

struct task1params {
  int bindPort;
  int bindFd;
};

/**
 *
 *
 *
 */
/*static void processReaper( int signal )
{
  int status, pid;

  fprintf( stderr, "%lu: i'm the process reaper\n", pthread_self() );
  if( signal != SIGCHLD ) {
    fprintf( stderr, "%lu: received something else that a SIGCHLD(%d)\n", pthread_self(), signal );
    return;
  }
  while( (pid = wait4(0, &status, WNOHANG, NULL)) > 0) {
    if( WIFSIGNALED(status) ) {
      fprintf( stderr, "%lu: child %d ended abnormaly(%d)\n", pthread_self(), pid, WEXITSTATUS(status) );
    }
  }  
  }*/


/**
 *   Verifies that /sbin/true is really true(we never know)
 *
 *
 */
void task1_core( void )
{
  FILE *fd;
  char buffer[100];

  tlsData++;
  fd = popen("/bin/true", "r");
  if( fd == NULL ) {
    fprintf(stderr, "%s(%lu): popen failed(%s)\n", __func__, pthread_self(), strerror(errno) );
    sleep(10);
    return;
  }
  if( fgets( buffer, sizeof(buffer), fd) == NULL ) {
    if( pclose(fd) < 0 ) {
      fprintf(stderr, "%s(%lu): pclose failed(%s)\n", __func__, pthread_self(), strerror(errno) );
      sleep(10);
    } /*else {
      fprintf(stderr, "%s(%lu): fgets failed(%s)\n", __func__, pthread_self(), strerror(errno) );
      }*/
    return;
  }
  if( pclose(fd) < 0 ) {
    fprintf(stderr, "%s(%lu): pclose failed(%s)\n", __func__, pthread_self(), strerror(errno) );
    sleep(10);
    return;
  }
}

void bindPort( struct task1params *params )
{
  struct sockaddr_in addr;

  if(!params) {
    fprintf(stderr, "%s: don't give me an empty params\n", __func__ );
    return;
  }
  
  if( (params->bindFd = socket(AF_INET, SOCK_STREAM, 0)) < 0 ) {
    fprintf(stderr, "%s: unable to create a socket(%s)\n", __func__, strerror(errno) );
    return;    
  }
  addr.sin_family = AF_INET;
  addr.sin_addr.s_addr = htonl(INADDR_ANY);
  addr.sin_port = htons(params->bindPort);

  if( bind(params->bindFd, (struct sockaddr *)&addr, sizeof(addr)) < 0 ) {
    fprintf( stderr, "%s: unable to bind(%s)\n", __func__, strerror(errno) );
    close(params->bindFd);
    return;
  }

  if( listen(params->bindFd, 10) < 0 ) {
    fprintf( stderr, "%s: unable to listen(%s)\n", __func__, strerror(errno) );
    close(params->bindFd);
    return;
  }
}

void unbindPort( struct task1params *params )
{
  close( params->bindFd );
}

/**
 *
 *
 *
 */
void *do_task1( void *p_args )
{
  struct task1params *params = (struct task1params *)p_args;

  if( p_args ) {
    bindPort( params );
  };
  do {
    task1_core();
    sleep(2);
    printf("%s(%lu): tlsData=%u\n", __func__, pthread_self(), tlsData );
  } while( runtask1 );
  
  if( p_args ) {
    unbindPort( params );
  };
  task1ended = 1;
  return NULL;
}

int main( int argc, char *argv[] )
{
  pthread_t task1;
  int counter;
  struct task1params params, *task1args = NULL;

  /*  if( signal(SIGCHLD, processReaper) == SIG_ERR ) {
    fprintf( stderr, "%s(%lu): error setting SIGCHLD handler\n", __func__, pthread_self() );
    return 1;
    }*/
  
  if( argc > 2 ) task1args = &params;
  params.bindPort = 7899;
  if( pthread_create(&task1, NULL, do_task1, (void *)task1args) ) {
    fprintf(stderr, "%s(%lu): unable to create task1\n", __func__, pthread_self() );
    return 1;
  }
  
  for( counter = 10; counter; counter--) {
    task1_core();
    printf("%s(%lu): tlsData=%u\n", __func__, pthread_self(), tlsData );
    sleep(1);
  }
  runtask1 = 0;
  for( counter = 2; !task1ended && counter; counter-- );
  return 0;
}
